# coding: utf-8

"""
    BlockContent Spec

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from blockcontent.models.chart_content import ChartContent
from blockcontent.models.table_content import TableContent
from blockcontent.models.text_content import TextContent
from typing import Optional, Set
from typing_extensions import Self

class Block(BaseModel):
    """
    A content block, used to represent structured sections such as text, charts, etc.
    """ # noqa: E501
    type: StrictStr = Field(description="type of block")
    chart_content: Optional[ChartContent] = None
    table_content: Optional[TableContent] = None
    text_content: Optional[TextContent] = None
    __properties: ClassVar[List[str]] = ["type", "chart_content", "table_content", "text_content"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['chart', 'table', 'text']):
            raise ValueError("must be one of enum values ('chart', 'table', 'text')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Block from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of chart_content
        if self.chart_content:
            _dict['chart_content'] = self.chart_content.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_content
        if self.table_content:
            _dict['table_content'] = self.table_content.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_content
        if self.text_content:
            _dict['text_content'] = self.text_content.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Block from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "chart_content": ChartContent.from_dict(obj["chart_content"]) if obj.get("chart_content") is not None else None,
            "table_content": TableContent.from_dict(obj["table_content"]) if obj.get("table_content") is not None else None,
            "text_content": TextContent.from_dict(obj["text_content"]) if obj.get("text_content") is not None else None
        })
        return _obj


